"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createHandler = void 0;
const dntShim = __importStar(require("./_dnt.shims.js"));
const validate_js_1 = require("./validate.js");
const deps_js_1 = require("./deps.js");
/** Create HTTP request handler for `graphql-playground`. */
function createHandler(options) {
    return (req) => {
        const result = (0, validate_js_1.validateRequest)(req);
        if (!result[0]) {
            const error = result[1];
            const body = error.expose ? error.message : null;
            return new dntShim.Response(body, {
                status: error.status,
                statusText: deps_js_1.STATUS_TEXT[error.status],
                headers: error.headers,
            });
        }
        const page = (0, deps_js_1.renderPlaygroundPage)(options);
        return new dntShim.Response(page, {
            status: deps_js_1.Status.OK,
            statusText: deps_js_1.STATUS_TEXT[deps_js_1.Status.OK],
            headers: {
                "content-type": (0, deps_js_1.contentType)("text/html"),
                ...result[1]?.headers,
            },
        });
    };
}
exports.createHandler = createHandler;
